import React from 'react';
import { AlignCenter } from '../layout';
import { Button } from 'antd';
import Modals from '../PublicModal/Index';

function DeleteBox({ 
  visible , 
  onCancel ,
  onSuccess ,
  title ,
  subTitle,
  content
}) {
  return(
    <Modals 
      title={title} 
      btn={
        <div>
          <Button size={'large'} onClick={onCancel}>取消</Button>
          <Button type={"danger"} size={"large"} onClick={onSuccess}>确认删除</Button>
        </div>
      } 
      onCancel={onCancel} 
      visible={visible}
    >
      <div className="desc">
        <AlignCenter className="descMain"><i className="iconfont icon-shanchu_tc_icon mr10"></i>{content}</AlignCenter>
      <p>{subTitle}</p>
      </div>
    </Modals>
  )
}
export default DeleteBox;