import React from 'react';
import { AlignCenter } from '../../Component/layout';
import Modals from '../../Component/PublicModal/Index';
import { Button } from 'antd';

function DeleteBox({ visible , onCancel ,onSuccess }) {
  
  return(
    <Modals
      visible={visible}
      onCancel={onCancel}
      title={"删除SSH密钥"}
      btn={
        <div>
          <Button size={'large'} onClick={onCancel}>取消</Button>
          <Button type={"danger"} size={"large"} onClick={onSuccess}>确认删除</Button>
        </div>
      }
    >
      <div className="desc">
        <AlignCenter className="descMain">
          <i className="iconfont icon-jinggao1 mr10 font-20 red"></i>您确定要删除此 SSH 密钥吗？</AlignCenter>
          <p>此操作将永久删除该SSH密钥，且不可恢复。如果您想再次使用该密钥，则需要您重新上传。</p>
      </div>
    </Modals>
  )
}
export default DeleteBox;