import { httpUrl } from '../fetch';

export const editorConfig = {
  placeholder: '请输入',
  uploadImgServer: httpUrl + '/busiAttachments/upload',
  uploadFileName: 'file',
  uploadImgHeaders: {
    'X-Requested-With': 'XMLHttpRequest'
  },
  excludeMenus: [
    'list',
    'todo',
    'emoticon',
    'video'
  ],
  uploadImgHooks: {
    // 图片上传并返回了结果，想要自己把图片插入到编辑器中
    customInsert: function (insertImgFn, result) {
      // insertImgFn 可把图片插入到编辑器，传入图片 src ，执行函数即可
      if (result && result.data && result.data.id) {
        insertImgFn(`${httpUrl}/busiAttachments/view/${result.data.id}`);
      }
    }
  },
}


export const weekModal="|  工作项目 | 本周工作计划  |  本周完成情况 |下周计划   |  待协同事项 |\n| ------------ | ------------ | ------------ | ------------ | ------------ |\n|   |   |   |   |   |\n|   |   |   |   |   |\n|   |   |   |   |   |\n|   |   |   |   |   |\n\n 备注:";
export const monthModal="|工作项目 | 工作内容 | 项目进度情况 | 问题列表及解决方案| 下月工作计划 | 遗留未解决的问题 |\n| ------------ | ------------ | ------------ | ------------ | ------------ | ------------ |\n|   |   |   |   |   |   |\n|   |   |   |   |   |   |\n|   |   |   |   |   |   |\n|   |   |   |   |   |   |\n\n 月度总结：";
